//****************************************************************************
//	aisa15s.pas
//
//	aISA-A15
//
//	Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
//
//	Date 1998/03/05
//
//	̃\[Xɂ̓bp[֐̎gpႪLqĂ܂B
//
//****************************************************************************
unit aisa15s;

interface

uses
	Windows, Messages, SysUtils, Forms, aisa15w;

const
	szTitle = 'Sample';
	szA15	 = 'aISA-A15';

type
	TForm1 = class(TForm)
		procedure FormCreate(Sender: TObject);
	private
		procedure ResultMessage(strbuf: String);
		procedure ErrorMessage(wLogSlot: Word);
	public
		{ Public 錾 }
	end;

var
	Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
var
	strbuf:	 String;
	dwDLLVer,  dwVxdVer: DWord;
	bResult:	 Boolean;					// 
	wLogSlot:  Word;						// foCXi[
	ri:				 TAISA15RESOURCE;	// \[X
	md:        TAISA15MODE;			// TvO[h
	dwNumData: DWord;
	dwStatus:  DWord;
	Data:      TVXDBUFF;
	i:         Integer;
	dwExIn0,   dwExIn1, dwExTrg: DWord;
	hWnd:			 THandle;
  InitArg:  DWord;
begin
//---------------------------------------------------------------------------
	// aisa15.dll ̎gp錾
	if Aisa15wDllOpen() = False then
	begin
		ErrorMessage(AISA15_SLOT_AUTO);
		Exit;			// aisa15.dll ̃[hɎs܂
	end;

//---------------------------------------------------------------------------
	// o[Wԍ\
	// aISA-A15 DLL,VxD̃o[Wԍ擾
	if Aisa15wGetVersion(dwDLLVer, dwVxdVer) = False then
	begin
		ErrorMessage(AISA15_SLOT_AUTO);
		Exit;
	end;

	strbuf := Format('GetVersion'#10 +
					 'DLL Version: %08xH'#10 +
					 'Vxd Version: %08xH',
										 [dwDLLVer, dwVxdVer]);

	ResultMessage(strbuf);

//---------------------------------------------------------------------------
	// aISA-A15̎gp錾
	wLogSlot := AISA15_SLOT_AUTO;		// gp̃foCXT܂B
	hWnd    := 0;
  InitArg := 0;
	bResult := Aisa15wCreate(wLogSlot,	// ꍇA̎̃foCXi[܂B
							hWnd,							// EBhEnhȂ̂ 0 Zbg܂B
																// EBhEnhZbg΁Ae
																// bZ[W܂B
							InitArg);



	if bResult = False then		// foCX܂B
	begin
		ErrorMessage(AISA15_SLOT_AUTO);
		Exit;
	end;

	strbuf := Format('aISA-A15 Created'#10#10 +
									 'LogSlot: %2d', [wLogSlot]);

	ResultMessage(strbuf);

//---------------------------------------------------------------------------
	// \[X擾
	if Aisa15wGetResource(wLogSlot, @ri) = False then
	begin
		ErrorMessage(wLogSlot);
		Exit;
	end;

	strbuf := Format('Board Name: %s'#10 +
									 'NumPorts: %2d'#10 +
									 'IO Address: %04xH-%04xH'#10 +
                   'IRQ: %2d'#10 +
                   'DMA: %2d',
										 [szA15, ri.wIOPortLength[1],
											ri.wIOPortBase[1],
											ri.wIOPortBase[1] + ri.wIOPortLength[1] - 1,
                      ri.bIRQRegisters[1],
                      ri.bDMALst[1]]);

	ResultMessage(strbuf);

//---------------------------------------------------------------------------
	// TvO[h̐ݒ
	md.iChFirst := 0;			// TvOJn`l(0 ` 15)
	md.iChLast	:= 15;		// TvOI`l(0 ` 15)
	md.cwBuffer := 256;		// obt@TCYi[hPʁj
	md.dwTimer	:= 500;		// ^C}l(1`50000000)
	md.dwMode	  := MODE_03;	// 샂[h(1`10)

	if Aisa15wSetMode(wLogSlot, @md) = False then
  begin
		ErrorMessage(wLogSlot);
		Exit;
  end;

	strbuf := Format('aISA-A15 Sampling Mode'#10 +
					         'TvOJn`l=%d'#10 +
									 'TvOI`l=%d'#10 +
									 'obt@TCY=%d'#10 +
									 '^C}l=%d'#10 +
									 '샂[h=%d',
									 [md.iChFirst, md.iChLast, md.cwBuffer,
                    md.dwTimer, md.dwMode]);

	ResultMessage(strbuf);

//---------------------------------------------------------------------------
	// TvOJn
	if Aisa15wStartSampling(wLogSlot) = False then
	begin
		ErrorMessage(wLogSlot);
		Exit;
	end;

	ResultMessage('aISA-A15 Sampling Started');

//---------------------------------------------------------------------------
	// TvOEXe[^X̎擾
	if Aisa15wGetSamplingStatus(wLogSlot, dwNumData, dwStatus) = False then
	begin
		ErrorMessage(wLogSlot);
		Exit;
	end;

	strbuf := Format('TvOEXe[^X擾'#10 +
					         'f[^=%d'#10 +
					         'Xe[^X=%d',
						       [dwNumData, dwStatus]);

	ResultMessage(strbuf);

//---------------------------------------------------------------------------
	// TvOς݃f[^̎擾
	if dwNumData > 0 then
	begin
 		for i:=1 to (AISA15_CH_MAX)*(AISA15_BUFF_PCH_MAX-1) do Data[i]:=0;

		if Aisa15wGetData(wLogSlot, dwNumData, @Data) = False then
		begin
			ErrorMessage(wLogSlot);
			Exit;
		end;

		strbuf := 'TvOς݃f[^擾'#10;
		for i := 1 to dwNumData -1 do
  	begin
			strbuf := strbuf + Format('%d:%.xH  ', [i, Data[i]]);

			if (i + 1) mod 4 = 0 then	// 4 Ŋ؂
				strbuf := strbuf + #10;
		end;

		ResultMessage(strbuf);
  end;

//---------------------------------------------------------------------------
	// TvO~
	if Aisa15wStopSampling(wLogSlot) = False then
	begin
		ErrorMessage(wLogSlot);
		Exit;
	end;

	ResultMessage('aISA-A15 Sampling Stopped');

//---------------------------------------------------------------------------
	// O͏Ԃ̎擾
	if Aisa15wGetExIn(wLogSlot, dwExIn0, dwExIn1, dwExTrg) = False then
	begin
		ErrorMessage(wLogSlot);
		Exit;
	end;

	strbuf := Format('O͏Ԃ̎擾'#10 +
					  'EXIN0̏=%.xH'#10 +
						'EXIN1̏=%.xH'#10 +
						'EXTRG̏=%.xH',
						[dwExIn0, dwExIn1, dwExTrg]);

	ResultMessage(strbuf);

//---------------------------------------------------------------------------
	// aISA-A15̎gpJ
	if Aisa15wClose(wLogSlot) = False then
	begin
		ErrorMessage(wLogSlot);
		Exit;
	end;

	ResultMessage('aISA-A15 Closed');

	// aisa15.dll ̎gpJ
	if Aisa15wDllClose() = False then
	begin
		Application.MessageBox(PChar('DLL ̃A[hɎs܂B'), szTitle, MB_OK + MB_ICONSTOP);
		Exit;			// aisa15.dll ̃A[hɎs܂B
	end;

end;

// ʂ\
procedure TForm1.ResultMessage(strbuf: String);
begin
	Application.MessageBox(PChar(strbuf), szTitle, MB_OK + MB_ICONINFORMATION);
end;

// G[bZ[W\
procedure TForm1.ErrorMessage(wLogSlot: Word);
var
	dwRes: DWord;
	strbuf: String;
begin
	dwRes := Aisa15wGetLastError(wLogSlot);

	case dwRes of
		AISA15_ERR_WRAPDLL:
			strbuf := 'DLL Load error';
	else
		strbuf := Format('aISA-A15 error'#10#10'Error code: %08xH',[dwRes]);
	end;

	Application.MessageBox(PChar(strbuf), szTitle, MB_OK + MB_ICONSTOP);
end;

end.
